/*
 * Copyright (c) 2011 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef _RELAYBOARD_H_
#define _RELAYBOARD_H_

#define RELAYBOARD_RQST_LEN 79
#define RELAYBOARD_DATA_LEN 110

typedef struct RELAYBOARD_STR {
	int fd;		        /* file descriptor */
	unsigned char buf[RELAYBOARD_DATA_LEN + 1];
	u_int16_t state;	/* state of the relays, including E-Stop */
	int16_t charge_c;	/* Charging current */
	int16_t voltage;	/* Battery voltage (mV) */
	int16_t temperature;	/* Board temperature */
	u_int16_t keypad;	/* keypad state */
} RELAYBOARD_STR;

extern RELAYBOARD_STR *relayboardInit(const char *);
extern void relayboardEnd(RELAYBOARD_STR *);
extern STATUS relayboardUpdate(RELAYBOARD_STR *, const char *);
extern void relayboardPrint(RELAYBOARD_STR *);
#endif
